<?php

include_once(dirname(__FILE__).'/../includes/Database.php');
include_once(dirname(__FILE__).'/../includes/system.php');
include_once(dirname(__FILE__).'/../includes/Update.php');
if(file_exists(dirname(__FILE__).'/../includes/config.php'))
  include_once(dirname(__FILE__).'/../includes/config.php');
include_once(dirname(__FILE__).'/UpdateTrace.php');
include_once(dirname(__FILE__).'/DefaultConfig.php');
include_once(dirname(__FILE__).'/../includes/Version.php');

function ControlPanel()
{
  global $UpdateManager;
	
  $YesNo = array(false => 'Ne', true => 'Ano');
  $Output = '<h3>Správa instance</h3>'.
    'Je instalováno: '.$YesNo[$UpdateManager->IsInstalled()].'<br/>';
  if($UpdateManager->IsInstalled())
    $Output .= 'Je aktuální: '.$YesNo[$UpdateManager->IsUpToDate()].'<br/>'.
    'Verze databáze: '.$UpdateManager->GetDbVersion().'<br/>';
  $Output .= 'Verze kódu: '.$UpdateManager->Revision.'<br/>'.
    '<form action="?" method="post">';
  if($UpdateManager->IsInstalled())
  {
    if(!$UpdateManager->IsUpToDate())
      $Output .= '<input type="submit" name="update" value="Aktualizovat"/>';
    $Output .= '<input type="submit" name="uninstall" value="Odinstalovat"/>';
  } else $Output .= '<input type="submit" name="install" value="Instalovat"/>';
  $Output .= '<input type="submit" name="configure" value="Nastavit"/>';
  $Output .= '</form>';
  return($Output);
}

function PrepareConfig($Config)
{
  $Output = '<h3>Nastavení systému</h3>'.
    '<form action="" method="post">'.
    '<table>'.  
    '<tr><td>Adresa serveru:</td><td> <input type="text" name="Host" value="'.$Config['Database']['Host'].'"/></td></tr>'.
    '<tr><td>Přihlašovací jméno:</td><td> <input type="text" name="User" value="'.$Config['Database']['User'].'"/></td></tr>'.
    '<tr><td>Heslo:</td><td> <input type="password" name="Password"/></td></tr>'.
    '<tr><td>Schéma:</td><td> <input type="text" name="Schema" value="'.$Config['Database']['Database'].'"/></td></tr>'.
    '<tr><td>Relativní URL cesta:</td><td> <input type="text" name="BaseURL" value="'.$Config['Web']['BaseURL'].'"/></td></tr>'.
    '<tr><td>Titulek webu:</td><td> <input type="text" name="Title" value="'.$Config['Web']['Title'].'"/></td></tr>'.
    '<tr><td>Email správce:</td><td> <input type="text" name="AdminEmail" value="'.$Config['Web']['AdminEmail'].'"/></td></tr>'.
    '<tr><td>Počet položek navigace stránkování:</td><td> <input type="text" name="VisiblePagingItems" value="'.$Config['Web']['VisiblePagingItems'].'"/></td></tr>'.
    '<tr><td>Počet řádků tabulek na stránku:</td><td> <input type="text" name="ItemsPerPage" value="'.$Config['Web']['ItemsPerPage'].'"/></td></tr>'.
    
    '<tr><td colspan="2"><input type="submit" name="configure_save" value="Nastavit"/></td></tr>'.
    '</table>'.  
    '</form>';
  return($Output);
}

function ConfigSave($DefaultConfig)
{
  $Config = $DefaultConfig;
  if(array_key_exists('Host', $_POST)) $Config['Database']['Host'] = $_POST['Host'];
  if(array_key_exists('User', $_POST)) $Config['Database']['User'] = $_POST['User'];
  if(array_key_exists('Password', $_POST) and ($_POST['Password'] != '')) $Config['Database']['Password'] = $_POST['Password'];
  if(array_key_exists('Schema', $_POST)) $Config['Database']['Database'] = $_POST['Schema'];
  if(array_key_exists('Title', $_POST)) $Config['Web']['Title'] = $_POST['Title'];
  if(array_key_exists('BaseURL', $_POST)) $Config['Web']['BaseURL'] = $_POST['BaseURL'];
  if(array_key_exists('AdminEmail', $_POST)) $Config['Web']['AdminEmail'] = $_POST['AdminEmail'];
  if(array_key_exists('VisiblePagingItems', $_POST)) $Config['Web']['VisiblePagingItems'] = $_POST['VisiblePagingItems'];
  if(array_key_exists('ItemsPerPage', $_POST)) $Config['Web']['ItemsPerPage'] = $_POST['ItemsPerPage'];
  $ConfigText = CreateConfig($Config);
  file_put_contents('../includes/config.php', $ConfigText);
  $Output .= 'Konfigurace nastavena';
  return($Output);	
}

function CreateConfig($Config)
{
  $Output = "<?php

  \$IsDeveloper = in_array(\$_SERVER['REMOTE_ADDR'], array('127.0.0.1'));

  \$Config = array(
  'Database' => array(
    'Host' => '".$Config['Database']['Host']."',
    'User' => '".$Config['Database']['User']."',
    'Password' => '".$Config['Database']['Password']."',
    'Database' => '".$Config['Database']['Database']."',
    'DatabaseAoWoW' => 'wowpreklad_mangos',
    'Prefix' => '',
    'Charset' => 'utf8',
    'MangosPrefix' => '',
  ),
  'Style' => 'maron',
  'Web' => array(
    'Title' => '".$Config['Web']['Title']."',
    'Charset' => 'utf-8',
    'Host' => 'localhost',
    'BaseURL' => '".$Config['Web']['BaseURL']."',
    'AdminEmail' => '".$Config['Web']['AdminEmail']."',
    'Authors' => 'autor',
    'ShowSQLQuery' => false,
    'ShowSQLError' => \$IsDeveloper,
    'ShowPHPError' => \$IsDeveloper,
    'ShowRuntimeInfo' => \$IsDeveloper,
    'FormatOutput' => \$IsDeveloper,
  	'ItemsPerPage' => ".$Config['Web']['ItemsPerPage'].",
    'TempFolder' => '../tmp/',
    'GameVersion' => '3.3.5a',
    'VisiblePagingItems' => ".$Config['Web']['VisiblePagingItems'].",
    'WebCounter' => '',
    'Timezone' => 'Europe/Prague',
  ),
  'ExportTaskProcessPeriod' => 10,
  'MaxExportPerUser' => 10,
  'AoWoWExportId' => 1,
);

?>";
  return($Output);
}

$Output = '<?xml version="1.0" encoding="utf-8"?>
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cz">'.
'<head>'.
'<meta http-equiv="content-type" content="application/xhtml+xml; charset=utf-8" />'.
'<title>Správa instance</title>'.
'</head><body>';
if(isset($Config))
{
  $System = new System();
  $System->Init();
  $UpdateManager = new UpdateManager();
  $UpdateManager->Database = $System->Database;
  $UpdateManager->Revision = $DatabaseRevision;
  $UpdateManager->Trace = $Updates;
  $UpdateManager->InstallMethod = 'FullInstall';

if(array_key_exists('update', $_POST))
{
  $Output .= '<h3>Aktualizace</h3>';
  $UpdateManager->Update();
  $Output .= ControlPanel();
} else
if(array_key_exists('install', $_POST))
{
  $Output .= '<h3>Instalace</h3>';
  $UpdateManager->Install();
  $Output .= ControlPanel();
} else
if(array_key_exists('uninstall', $_POST))
{
  $Output .= '<h3>Odinstalace</h3>';
  $UpdateManager->Uninstall();
  $Output .= ControlPanel();
} else
if(array_key_exists('configure_save', $_POST))
{
  $Output .= ConfigSave($Config);
  $Output .= ControlPanel();	
} else 
if(array_key_exists('configure', $_POST))
{
  $Output .= PrepareConfig($Config);
} else
{
  $Output .= ControlPanel();	
}
} else 
{
  if(array_key_exists('configure_save', $_POST))
  {
    $Output .= PrepareConfig($Config);
    $Output .= ControlPanel();	
  } else {
  	$Output .= PrepareConfig($DefaultConfig);
  }
}
$Output .= '</body></html>';
echo($Output);

?>
